/* VGAlib version 1.2 - (c) 1993 Tommy Frandsen 		   */
/*								   */
/* This library is free software; you can redistribute it and/or   */
/* modify it without any restrictions. This library is distributed */
/* in the hope that it will be useful, but without any warranty.   */

/* Multi-chipset support Copyright 1993 Harm Hanemaayer */
/* partially copyrighted (C) 1993 by Hartmut Schirmer */

#include <stdlib.h>
#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <sys/ioctl.h>

#include "vga.h"
#include "libvga.h"

void vga_waitretrace() {
	while (!(inb(0x3da) & 8));
	while (inb(0x3da) & 8);
}

unsigned char *vga_getgraphmem() {
	return __svgalib_graph_mem;
}

int vga_getkey() {
	struct termio zap, original;
	char c;
	int e;

	ioctl(fileno(stdin), TCGETA, &original);	/* Get termio */
	zap = original;
	zap.c_cc[VMIN] = 0;				/* Modify termio  */
	zap.c_cc[VTIME] = 0;
	zap.c_lflag = 0;
	ioctl(fileno(stdin), TCSETA, &zap);		/* Set new termio */
	e = read(fileno(stdin), &c, 1);			/* Read one char */
	ioctl(fileno(stdin), TCSETA, &original);	/* Restore termio */
	if (e != 1)
		return 0;				/* No key pressed. */
	return c;					/* Return key. */
}

static void reserved_message() {
	printf("svgalib: Function not present in shared library image.\n");
	printf("         You need a newer version of svgalib.\n");
}

void vga_reserved1() {
	reserved_message();
}
void vga_reserved2() {
	reserved_message();
}
void vga_reserved3() {
	reserved_message();
}
void vga_reserved4() {
	reserved_message();
}
void vga_reserved5() {
	reserved_message();
}
void vga_reserved6() {
	reserved_message();
}
void vga_reserved7() {
	reserved_message();
}
void vga_reserved8() {
	reserved_message();
}
