/* VGAlib version 1.2 - (c) 1993 Tommy Frandsen 		   */
/*								   */
/* This library is free software; you can redistribute it and/or   */
/* modify it without any restrictions. This library is distributed */
/* in the hope that it will be useful, but without any warranty.   */

/* Multi-chipset support Copyright 1993 Harm Hanemaayer */
/* partially copyrighted (C) 1993 by Hartmut Schirmer */

#include <stdlib.h>

#include "vga.h"
#include "libvga.h"


int vga_setpalette(int index, int red, int green, int blue)
{
    /* select palette register */
    port_out(index, PEL_IW); 

    /* write RGB components */
    __vga_delay();
    port_out(red, PEL_D);
    __vga_delay();
    port_out(green, PEL_D);
    if (SCREENON) {		 /* writing the `blue' register will   */
      while (!(inb(0x3da) & 1)); /* load the dac. Waiting for vertical */
      while (inb(0x3da) & 1);    /* or horizontal retrace will load    */
    } else			 /* the dac without disturbances       */	
      __vga_delay();
    port_out(blue, PEL_D);
    return 0;
}


int vga_getpalette(int index, int *red, int *green, int *blue)
{
    /* select palette register */
    port_out(index, PEL_IR);

    /* read RGB components */
    __vga_delay();
    *red = (int) port_in(PEL_D);
    __vga_delay();
    *green = (int) port_in(PEL_D);
    __vga_delay();
    *blue = (int) port_in(PEL_D);

    return 0;  
}


int vga_setpalvec(int start, int num, int *pal)
{
    int j;

    /* select palette register */
    port_out(start, PEL_IW);

    for(j = 0; j < num; j++) {
        __vga_delay();
        port_out(*(pal++), PEL_D);
        __vga_delay();
        port_out(*(pal++), PEL_D);
	if (SCREENON) {		     /* writing the `blue' register will   */
	  while (!(inb(0x3da) & 1)); /* load the dac. Waiting for vertical */
	  while (inb(0x3da) & 1);    /* or horizontal retrace will load    */
 	} else			     /* the dac without disturbances       */	
	  __vga_delay();
        port_out(*(pal++), PEL_D);
    }

    return j;
}


int vga_getpalvec(int start, int num, int *pal)
{
    int j;

    /* select palette register */
    port_out(start, PEL_IR);

    for(j = 0; j < num; j++) {
        __vga_delay();
        *(pal++) = (int) port_in(PEL_D);
        __vga_delay();
        *(pal++) = (int) port_in(PEL_D);
        __vga_delay();
        *(pal++) = (int) port_in(PEL_D);
    }

    return j;
}



